Subject: Alarm #38, #43 - trap/notification varbind and timestamps

From: "Sharon Chisholm" <[email-masked]>
Date: Mon, 3 Jun 2002 08:53:41 -0400

hi

Since potentially always treating notification varbinds like
they are NOTIFICATION-TYPE in #38 is related to the always
storing varbinds as if they are from notifications, as appose
to v1 traps, in #43, I've grouped these two:

Alarm #38 Description of object alarmModelVarbindIndex 
  Option 1) Change "For SNMPv1 traps, a 1 indicates the first varbind. For
  NOTIFICATION-TYPE," to "For v1Traps,For v2Traps and Informs, a 1 indicates
  the first varbind. ". 
  Option 2) Alternatively, always treat it like v2 traps

  Solution: For consistency with #43 and to comply with the
  philosophy of 2576, notifications, regardless of the protocol
  will be treated *as though* they were NOTIFICATION-TYPE. We still
  need to provide guidance of how to use this with v1 traps, as
  well as indicate whether an index of 3 is the third varbind in the
  notification on the wire, or as defined in the SMI. Therefore, the
  the text from option 1) still applies:

   "For SNMPv1 traps, a 1 indicates the first varbind. For
         v2Traps and Informs, a 1 indicates the first real varbind
         after the required varbinds of sysUptime and SNMPTrapOID.".

Alarm #43 Timestamp Description & Do we need two timestamps
  Change text to:
  'The time that the error information was added to the alarm table. 
  The time when the error occurred may be retrieved from a different 
  source, e.g. from the variable bindings of the notification if a 
  distributed system using notifications for alarm generation is 
  being implemented'.
  Does this then require sysUptime and trapOID to be stored in 
    alarmActiveVariableTable, even for v1 traps?
 
  Solution: Change text as described above. Always store notifications
    as if they are NOTIFICATION-TYPE/v2 traps/informs.

Sharon Chisholm
Preside Management
Nortel Networks
Ottawa, Ontario

---

From: "Romascanu, Dan (Dan)" <[email-masked]>
Date: Sun, 16 Jun 2002 12:48:06 +0300

Tom, 
 
Would the following edit for #43 reflect your intention?
 
'The time when the error occurred MAY be retrieved from a different source. If a   distributed system using notifications for alarm generation is being implemented, then he time when the error occurred SHOULD be retrieved from the variable bindings of the notification. '
 
Regards,
 
Dan

-----Original Message-----
From: Tom Petch [mailto:[email-masked]]
Sent: Thursday, June 13, 2002 8:15 PM
To: Sharon Chisholm; [email-masked]
Subject: Re: Alarm #38, #43 - trap/notification varbind and timestamps

I believe the same index should retrieve the same value, regardless of v1 or v2 ie 1 for sysUpTime, 2 for SNMPTrapOID etc.  It is simple., it is logical.  But I am not clear from the text if that is an option you are offering me  !
Tom Petch, Network Consultant
[email-masked]

-----Original Message-----
From: Sharon Chisholm < [email-masked]>
To: [email-masked] < [email-masked]>
Date: 06 June 2002 04:22
Subject: Alarm #38, #43 - trap/notification varbind and timestamps

hi 

  

Sharon Chisholm 
Preside Management 
Nortel Networks 
Ottawa, Ontario

---

From: "Romascanu, Dan (Dan)" <[email-masked]>
Date: Wed, 19 Jun 2002 10:57:08 +0300

> From: David Partain [mailto:[email-masked]]
> Sent: Wednesday, June 19, 2002 10:13 AM
> To: Randy Presuhn; [email-masked]
> Hi all,
> > > > On Thursday 13 June 2002 19.14, Tom Petch wrote:
> > > > I believe the same index should retrieve the same 
> value, regardless of
> > > > v1 or v2 ie 1 for sysUpTime, 2 for SNMPTrapOID etc.  It 
> is simple., it
> > > > is logical.  But I am not clear from the text if that 
> is an option you
> > > > are offering me  !
> 
> I responded:
> > > There is no varbind holding sysUpTime.0 or SNMPTrapOID in
> > > an SNMPv1 trap.  They are embedded in the message wrapper.
> > > As such, what you are asking for is not possible.
> > >
> > > Since the first two VarBinds in a v2c/v3 trap/inform somewhat
> > > approximate information that's in the message wrapper for
> > > SNMPv1 traps, I thought Sharon's proposed text was just fine
> > > (I removed the "real" from "real varbinds" since I don't know
> > > how to send a "fake" varbind).
> > >
> > > That is:
> > >
> > >  v2Traps and Informs, a 1 indicates the first varbind after
> > >  the required varbinds of sysUptime and SNMPTrapOID."
> 
> Then, Randy P. wrote:
> 
> > The same logic leads me, as a technical contributor, down a
> > very different path.
> >
> > In order to avoid losing information and to maintain the
> > valuable distinction between the notification and the active
> > alarm's time stamps, I would suggest that we follow the RFC 2576
> > rules (section 3.1) so that everything is represented as though
> > it had arrived in RFC 1905 format.  I think this is ultimately
> > simpler than introducing a new set of rules peculiar to this
> > MIB to treat everything as though it were SNMPv1.
> 
> That's absolutely fine with me.  In that case, the DESCRIPTION
> for alarmModelVarbindIndex needs to explain this.  The issue
> remains that if that holds a value of 2, and that's going to
> refer to the trap OID even if the incoming notification is a v1
> trap, then there must be some information in this description
> that states that.  Otherwise, I think there's a strong risk for
> confusion.
> 
> How about this as a replacement for the second paragraph of
> the DESCRIPTION:
> 
>   "Note that the value of alarmModelVarbindIndex assumes
>   the existence of the first two obligatory varbinds in
>   the InformRequest-PDU and SNMPv2-Trap-PDU (sysUpTime.0
>   and snmpTrapOID.0).  That is, a value of 1 refers to
>   sysUpTime.0, and a value of 3 refers to the first varbind
>   after snmpTrapOID.0.
> 
>   If the incoming notification is instead an SNMPv1 Trap-PDU and
>   the value of alarmModelVarbindIndex is 1 or 2, an appropriate
>   value for sysUpTime.0 or snmpTrapOID.0 shall be determined
>   by using the rules in section 3.1 of [appropriate reference
>   for RFC2576]."
> 
> That way, a 1 always means sysUpTime and a 3 always means the
> first "real" varbind.
> 
> Did I understand what you want?  Does this work?

I think it does. Regards, Dan

---

From: "Tom Petch" <[email-masked]>
Date: Sun, 23 Jun 2002 15:46:17 +0100

Yes, Randy's suggestion is an improvement; also simple, logical and as
you
rightly say, in line with RFC2576.

(and yes, David,  I do know the details of trap PDUs in RFC1157,
RFC1448, RFC1905 etc :-)

-----Original Message-----
From: Romascanu, Dan (Dan) <[email-masked]>
To: [email-masked] <[email-masked]>; Randy
Presuhn <[email-masked]>; [email-masked]
<[email-masked]>
Date: 19 June 2002 08:59
Subject: RE: Alarm #38, #43 - trap/notification varbind and timestamps